@echo off
:: ===============================================================================
:: AppFileName:	Download.cmd
:: Date:		2024-02-07 08:08
:: Version:		1.24.02
:: Author:		lsl
::
:: Use curl.exe to download files
:: Parameter:	1.ini\*.ini	(subdir)
::					ini is the default folder
::
::				2.all/del/curl/desktop	/lnk
::					all 	Run download and install
::					del 	Del Downloaded Files and Run all again
::					curl	Use curl.exe to Download
::					desktop	For install app copying lnk file to all users desktop
::					lnk		for portable app use Shortcut.exe to create lnk file
:: ===============================================================================

rem ====----	Run a command as an Administrator from the Windows command line
set "Driver=%~d0"
set "FilePath=%~p0"
rem %ComSpec% /C powershell "Start-Process cmd -Verb RunAs -ArgumentList '/c exit '" && cd "%Driver%%FilePath%"
cd "%Driver%%FilePath%"
%Driver%

setlocal
rem ====----	Parameter Example
set CmdFile=%~n0
if /i "%~1"=="" (
	set /a para_a=0
	echo Example:%CmdFile% ini\7-zip.ini all/curl/del/lnk/desktop
	echo 	%CmdFile%	Command File
	echo Parameter
	echo		7-zip.ini	Setting File for download and install
	echo 	ini\		path
	echo 	all		Install all
	echo 	curl		curl download only
	echo 	del		Del old download file
	echo 	lnk/desktop 	copy or create lnk file
	exit /b
) else (
	set /a para_a=1
)

rem ====----	para_b=0 lnk only
if /i "%~2"=="" (
	set /a para_b=0
) else (
	set /a para_b=1
)

rem ====----	desktop lnk EQU ""
if /i "%~2"=="desktop" (
	set /a para_b=0
)

if /i "%~2"=="lnk" (
	set /a para_b=0
)

rem ====----	Dwonload only	No Install all/curl
setlocal
set Driver=%~d0
set FilePath=%~p0
set "ConfFile=%~1"

rem ====----	check .ini
if /i %ConfFile:~-3% EQU ini (
	set "Config_ini=%Driver%%FilePath%%ConfFile%"
) else (
	set "Config_ini=%Driver%%FilePath%%ConfFile%.ini"
)

rem ====----	Initialize Variable
call :iniVariable

rem ====----	Read ini File
call :ReadiniFile

rem ====----	initialize	Set Path Variable
call :SetVariable

rem ====----	Must be after SetVariable
if /i "%~2"=="curl" (
	set /a Install=0
	set /a IsCurl=1
) else (
	set /a Install=1
	set /a IsCurl=2
)

rem ====----	Set Color
call :ColorSet

rem ====----	Checkdir
call :Checkdir Downloads
call :Checkdir Downloads\%AppName%
call :Checkdir Downloads\%AppName%\%Version%

if defined ToLinkFolder (
	rem PUBLIC=C:\Users\Public
	call :Checkdir %PUBLIC%%ToLinkFolder%
)

rem ====----	Delete old Download File
if /i "%~2"=="del" (
	del /F /Q "%PathFilename%"
)

rem ====----	%IsCurl%=1	Download Only
if %IsCurl% EQU 1 (
	call :RunCurl
	goto End
)

rem ====----	Not downloaded yet
if not exist "%PathFilename%" (
	call :RunCurl
)

rem ====----	ChkFileExtension	zip 7z rar
if exist "%PathFilename%" (
	call :ChkFileExtension
)

rem ====----	USE 7-zip extract zip 7z rar
if %IsZip% EQU 1 (
	call :7z x "%PathFilename%" "%UnZipPath%" "%UnZipFile%"
	set "CopyUnZip=%UnZipPath%%UnZipFile%"
)

rem ====----	ChkInstallFile
call :ChkInstallFile

rem ====----	InstallFilename	SilentInstall
rem ====	start installation
if %Install% NEQ 0 (
	echo %ClolorYellow_BT%"%InstallFilename%" %SilentInstall%%DefaultClolor%
	::	msi	or	exe
	if /i %InstallFilename:~-3% EQU msi (
		call msiexec /i "%InstallFilename%" %SilentInstall%
	) else (
		call "%InstallFilename%" %SilentInstall%
	)
)

rem ====----	copy lnk file
if defined LinkFile (
	rem ====----	Set Link Environment for copy LinkFile
	call :CopyLinkFile
)

rem ====----	copy Crack file
if defined ToRegistFile (
	call :CopyToRegistFile
)

goto End

:iniVariable
	set AppName=
	set URL=
	set Download=
	set FileName=
	set Version=
	set FileDate=
	set SilentInstall=
	rem ====	WinNTsetup	WinNTSetup_v533b.rar
	set MediaFire=
	set dButton=

	set UnZipFile=
	set UnZipFolder=
	rem ====	NTPClock.exe
	set NotZipFile=
	rem ====	winampac3_1_20a.exe
	set ExeUnZip=
	rem ====	DefenderControl	dControl.zip
	set PassWord=

	set LinkEnv=
	set LinkFile=
	set ToLinkFolder=

	set ToRegistEnv=
	set ToRegistFolder=
	set ToRegistFile=

	set RunXcopy=

	exit /b

:ReadiniFile
	rem ====----	setlocal enabledelayedexpansion
	rem ====----	Read ini File
	if not exist "%Config_ini%" (
		echo Cant Find %Config_ini%
		goto End
	)

	For /F "tokens=1* delims==" %%I in ('findstr /i "^[A-z]" "%Config_ini%"') do (
		set "%%I=%%J"
		rem if defined %%I (
		rem echo 	%%I	 = %%J
		rem )

		if defined %%I (
			set II=%%I
			::	Show only URL and Download
			if /i !II! EQU URL (echo 	%%I	 = %%J)
			if /i !II! EQU Download (echo 	%%I = %%J)
			if /i !II! EQU Version (echo 	%%I = %%J)
			if /i !II! EQU FileDate (echo 	%%I = %%J)
		)
	)
	echo.
	exit /b

:SetVariable
	rem ====----	Set Path Variable
	::	PathFilename
	::	InstallFilename
	::	DownloadPath

	::	ini AppName		Version			FileName
	::	ini UnZipFile	UnzipFolder

	::	ini	NotZipFile	ExeUnZip		PassWord
	::	ini	MediaFire	dButton

	::	ini LinkEnv		LinkFile		ToLinkFolder	ToLinkTarget
	::	ini ToRegistEnv	ToRegistFolder 	ToRegistFile

	::	ini RunXcopy

	set "PathFilename=%~d0%~p0Downloads\%AppName%\%Version%\%FileName%"
	set "InstallFilename=%PathFilename%"
	set "DownloadPath=%~d0%~p0Downloads\%AppName%\%Version%\"
	if defined UnZipFolder (
		set "UnZipPath=%~d0%~p0Downloads\%AppName%\%Version%%UnZipFolder%"
	) else (
		set "UnZipPath=%~d0%~p0Downloads\%AppName%\%Version%\"
	)

	set /a FileExist=0
	set /a Install=0

	set /a IsZip=0
	set /a IsUnZipFolder=0

	set /a IsCurl=0

	::	MediaFire
	set II=
	set Ihref=
	set Downloadhref=
	exit/b

:RunCurl
	rem ====----	curl.exe	:SetVariable	----	PathFilename
	if not defined Download (
		echo %ClolorRed_NT%Not defined Download%DefaultClolor%
	)

	rem ====----	MediaFire
	if defined MediaFire (
		goto RunMediaFire
	)

	if not exist "%PathFilename%" (
		curl.exe -LJR --url "%Download%" -o "%PathFilename%" -k --show-error --fail
	)

	if %errorlevel% NEQ 0 (
		echo.%ClolorRed_BT%
		echo An curl error was found : "%Download%"
		echo.%DefaultClolor%
		pause
	)

	if exist "%PathFilename%" (
		echo		Download:	"%PathFilename%"
		dir "%pathFilename%" | findstr /I "%Filename%"
	)
	exit /b

:RunMediaFire
	rem ====----	1.	Download WinNTSetup_v533b.rar.html
	::	WinNTSetup_v533b.rar.html
	curl.exe -LJR --url "%Download%" -o "%pathFilename%.html" -k --show-error --fail
	echo.

	if %errorlevel% NEQ 0 (
		echo.%ClolorRed_BT%
		echo An curl error was found : %Download%
		echo.%DefaultClolor%
		pause
	)

	rem ====----	2.	Create WinNTSetup_v533b.rar.href (Find downloadButton)
	::	WinNTSetup_v533b.rar.href
	echo.>"%pathFilename%.href"

	setlocal enabledelayedexpansion
	For /F "tokens=1* delims= " %%I in ('findstr /i "%dButton%" "%pathFilename%.html"') do (
		if %%I NEQ "" (
		set "II=%%I"
		set "Ihref=!II:~0,4!"
			if !Ihref! EQU href (
				echo 	%%I
				echo %%I >>"%pathFilename%.href"
			)
		)
	)

	echo.
	rem ====----	3.	Get download href from WinNTSetup_v533b.rar.ref
	For /F "tokens=1,2 delims==" %%I in ('findstr /i "href" "%pathFilename%.href"') do (
		if /i %%J NEQ "" (
			set "Downloadhref=%%J"
		)
	)
	set "Download=%Downloadhref:~1,-2%"
	echo 	Download = %Download%
	setlocal
	echo.

	rem ====----	4.	Download WinNTSetup_v533b.rar
	::	WinNTSetup_v533b.rar
	echo curl.exe -LJR --url "%Download%" -o "%pathFilename%" -k --show-error --fail
	curl.exe -LJR --url "%Download%" -o "%pathFilename%" -k --show-error --fail

	if %errorlevel% NEQ 0 (
		echo.%ClolorRed_BT%
		echo An curl error was found : %Download%
		echo.%DefaultClolor%
		pause
	)

	if exist "%PathFilename%" (
		echo		Download:	"%PathFilename%"
		dir "%pathFilename%" | findstr /I "%Filename%"
	)

	exit /b

:ChkFileExtension
	rem ====----	IsZip	Filename Extension is .zip
	::	i[""

	::	zip
	if /i %PathFilename:~-3% EQU zip (
		echo.
		echo %ClolorGreen_BT%%PathFilename:~-3%%DefaultClolor%
		set /a IsZip=1
	)

	::	rar
	if /i %PathFilename:~-3% EQU rar (
		echo.
		echo %ClolorGreen_BT%%PathFilename:~-3%%DefaultClolor%
		set /a IsZip=1
	)

	::	7z
	if /i %PathFilename:~-2% EQU 7z (
		echo.
		echo %ClolorGreen_BT%%PathFilename:~-3%%DefaultClolor%
		set /a IsZip=1
	)

	::	ExeUnZip
	if defined ExeUnZip (
		echo.
		echo %ClolorGreen_BT%%PathFilename:~-3%%DefaultClolor%
		set /a IsZip=1
	)

	exit /b

:ChkInstallFile
	rem ====----	INI	UnZipFolder
	::	Check if the unzipped subdirectory exists
	::	Does the downloaded file have a specified decompression directory?
	if defined UnZipFolder (
		echo Downloads\%AppName%\%Version%%UnZipFolder%
		::	1. Check the unzipped directory
		call :Checkdir Downloads\%AppName%\%Version%%UnZipFolder%
		::	1+2=3
		set /a IsUnZipFolder=2
	)

	rem ====----	IsZip	zipɸYbINIwq۫ظƧ	IsUnZipFolder
	::	1+2=3
	::	ˬdɮפwgY즸ؿ 1 2 3
	::	NEQ 0 Ozip	åBwYؿ
	rem ====----	IsCopyUnZip
	set /a IsCopyUnZip=%IsZip%+%IsUnZipFolder%
	if %IsCopyUnZip% NEQ 0 (
		set "CopyUnZip=%UnZipPath%%UnZipFile%"
	)

	rem ====----	Check Download Finished and Run Install
	::	ˬdO_Uɮ
	if exist "%PathFilename%" (
		echo.
		echo %ClolorYellow_BT%"%PathFilename%"%DefaultClolor%
		set /a FileExist=1
	)

	rem ====----	Install	InstallFilename
	::	ɮפwY æѼ %~2
	::	para_b O_ݭnw
	set /a Install=%FileExist%*%para_b%

	rem ====----	Install
	::	O_ݭnw
	if not defined SilentInstall (
		set /a Install=0
	)

	rem ====----	Install Silent
	::	wɬOEXE InstallFilename
	::	nϥΦwɪɦW	UɦW令ѪRY᪺ɦW
	::	exe
	if /i %UnZipFile:~-3% EQU exe (
		set "InstallFilename=%~d0%~p0Downloads\%AppName%\%Version%\%UnZipFile%"
	)

	::	msi
	if /i %UnZipFile:~-3% EQU msi (
		set "InstallFilename=%~d0%~p0Downloads\%AppName%\%Version%\%UnZipFile%"
	)

	exit /b

:CopyLinkFile
	setlocal enabledelayedexpansion
	rem ====----	enabledelayedexpansion
	if "%LinkEnv%" EQU "%%ProgramData%%" (
		set "LinkEnv=%ProgramData%"
	)

	if "%LinkEnv%" EQU "%%USERPROFILE%%" (
		set "LinkEnv=%USERPROFILE%"
	)

	if "%LinkEnv%" EQU "%%APPDATA%%" (
		set "LinkEnv=%APPDATA%"
	)

	if "%LinkEnv%" EQU "%%PUBLIC%%" (
		set "LinkEnv=%PUBLIC%"
	)

	rem ====----	LinkEnv
	set "LinkEnv=!LinkEnv!"

	rem ====----	copy linkFile
	rem ====	Public
	if exist %LinkEnv%%LinkFile% (
		echo.
		copy  /Y "%LinkEnv%%LinkFile%" "%Public%%ToLinkFolder%%ToLinkTarget%"
		echo %ClolorYellow_BT%"%LinkEnv%%LinkFile%"
		echo "%Public%%ToLinkFolder%%ToLinkTarget%"%DefaultClolor%
	)

	if %errorlevel% NEQ 0 (
		echo.%ClolorRed_BT%
		echo A copy lnk error was found : "%LinkEnv%%LinkFile%"
		echo.%DefaultClolor%
		pause
	)

	exit /b

:CopyToRegistFile
	rem ====----	copy ToRegistFolder
	call :Checkdir %ToRegistEnv%%ToRegistFolder%
	setlocal enabledelayedexpansion
	if "%ToRegistEnv%" EQU "%%ProgramFiles(x86)%%" (
		set "ToRegistEnv=%ProgramFiles(x86)%"
	)
	set ToRegistEnv=!ToRegistEnv!

	if "%ToRegistEnv%" EQU "%%ProgramFiles%%" (
		set "ToRegistEnv=%ProgramFiles%"
	)

	if "%ToRegistEnv%" EQU "%%USERPROFILE%%" (
		set "ToRegistEnv=%USERPROFILE%"
	)
	::	SystemDrive
	if "%ToRegistEnv%" EQU "%%SystemDrive%%" (
		set "ToRegistEnv=%SystemDrive%"
	)

	::	PUBLIC
	if "%ToRegistEnv%" EQU "%%PUBLIC%%" (
		set "ToRegistEnv=%PUBLIC%"
	)

	::	ALLUSERSPROFILE
	if "%ToRegistEnv%" EQU "%%ALLUSERSPROFILE%%" (
		set "ToRegistEnv=%ALLUSERSPROFILE%"
	)

	if "%ToRegistEnv%" EQU "%%ProgramData%%" (
		set "ToRegistEnv=%ProgramData%"
	)

	::	TEMP
	if "%TEMP%" EQU "%%TEMP%%" (
		set "ToRegistEnv=%TEMP%"
	)

	rem ====----	ToRegistEnv

	set "ToRegistEnv=!ToRegistEnv!"

	rem ====----	CopyUnZip

	rem ====----	Xcopy ToRegistFile	 esc color
	if defined RunXcopy (
		echo.
		set /a IsCopyUnZip=0
		rem ====	type .txt
		rem	::	 "%CopyUnZip%" "%ToRegistEnv%%ToRegistFolder%%ToRegistFile%" /s /Y /Q
		xcopy "%CopyUnZip%" "%ToRegistEnv%%ToRegistFolder%%ToRegistFile%"  /s /Y > "%ConfFile%_xcopy.txt"
		echo .
		type "%ConfFile%_xcopy.txt"
		del "%ConfFile%_xcopy.txt"

		echo %ClolorYellow_BT%"%CopyUnZip%"
		echo %ClolorYellow_BT%"%ToRegistEnv%%ToRegistFolder%%ToRegistFile%"%DefaultClolor%
	)

	if %errorlevel% NEQ 0 (
		echo.%ClolorRed_BT%
		echo A xcopy error was found : "%CopyUnZip%"
		echo.%DefaultClolor%
		pause
	)

	rem ====----	copy ToRegistFile
	rem ====	NotZipFile
	if defined NotZipFile (
		set "CopyUnZip=%PathFilename%"
		set /a IsCopyUnZip=1
	)

	rem ====	if exist "%UnZipPath%" (
	if %IsCopyUnZip% NEQ 0 (
		echo.
		copy /Y	"%CopyUnZip%" "%ToRegistEnv%%ToRegistFolder%%ToRegistFile%"
		rem	::	ToRegistEnv]() ҥH[""
		rem	::	echo %ClolorYellow_BT%"%InstallFilename%"
		echo %ClolorYellow_BT%"%CopyUnZip%"
		echo "%ToRegistEnv%%ToRegistFolder%%ToRegistFile%"%DefaultClolor%
	)

	if %errorlevel% NEQ 0 (
		echo.%ClolorRed_BT%
		echo An copy file error was found : "%CopyUnZip%"
		echo.%DefaultClolor%
		pause
	)

	exit /b

:ColorSet
	::	1 Normal Text
	set "ClolorBlack_NT=[30m"
	set "ClolorRed_NT=[31m"
	set "ClolorGreen_NT=[32m"
	set "ClolorYellow_NT=[33m"
	set "ClolorBlue_NT=[34m"
	set "ClolorMagenta_NT=[35m"
	set "ClolorCyan_NT=[36m"
	set "ClolorWhite_NT=[37m"

	::	2 Normal Background
	set "ClolorBlack_NB=[40m"
	set "ClolorRed_NB=[41m"
	set "ClolorGreen_NB=[42m"
	set "ClolorYellow_NB=[43m"
	set "ClolorBlue_NB=[44m"
	set "ClolorMagenta_NB=[45m"
	set "ClolorCyan_NB=[46m"
	set "ClolorWhite_NB=[47m"

	::	3 Bright Text
	set "ClolorBlack_BT=[90m"
	set "ClolorRed_BT=[91m"
	set "ClolorGreen_BT=[92m"
	set "ClolorYellow_BT=[93m"
	set "ClolorBlue_BT=[94m"
	set "ClolorMagenta_BT=[95m"
	set "ClolorCyan_BT=[96m"
	set "ClolorWhite_BT=[97m"

	::	4 Bright Background
	set "ClolorBlack_BB=[100m"
	set "ClolorRed_BB=[101m"
	set "ClolorGreen_BB=[102m"
	set "ClolorYellow_BB=[103m"
	set "ClolorBlue_BB=[104m"
	set "ClolorMagenta_BB=[105m"
	set "ClolorCyan_BB=[106m"
	set "ClolorWhite_BB=[107m"

	::	0 DefaultClolor
	set "DefaultClolor=[0m"

	exit /b

:Checkdir
	rem ====----	https://stackoverflow.com/questions/18639663/how-to-pass-command-line-parameters-with-space-in-batch-file

	if exist "%*" (
		exit /b
	)
	if not exist "%*" (
		mkdir "%*"
	)
	if exist "%*" (
		echo %* Created
	)
	exit /b

:7z
	rem ====----	parameters 1 2 3 4
	rem ====	mode file outpath file
	if exist %2 (
		echo "%ProgramFiles%\7-Zip\7z.exe" %1 -y %2 -o%3 %4 -p%password% -aoa
		"%ProgramFiles%\7-Zip\7z.exe" %1 -y %2 -o%3 %4 -p%password% -aoa
	) else (
		echo %2
		goto End
	)
	exit /b

:End
	echo.
	set para_a=
	set para_b=
	set para_c=
	exit /b
	rem	%ComSpec% /k